definition module osrgn

import ostoolbox

::	OSRgnHandle
	:==	Int

//	Region creation and disposal operations.
osnewrgn	::                                        !*OSToolbox -> (!OSRgnHandle,!*OSToolbox)
osdisposergn::                           !OSRgnHandle !*OSToolbox -> *OSToolbox

//	Setting the shape of a region to a rectangle or a polygon.
osrectrgn	:: !(!Int,!Int,!Int,!Int)    !OSRgnHandle !*OSToolbox -> (!OSRgnHandle,!*OSToolbox)
ospolyrgn	:: !(!Int,!Int) ![(Int,Int)] !OSRgnHandle !*OSToolbox -> (!OSRgnHandle,!*OSToolbox)

//	Combining the shapes of the two argument regions into a new region.
//	The argument regions are not changed.
ossectrgn	:: !OSRgnHandle !OSRgnHandle !*OSToolbox -> (!OSRgnHandle,!*OSToolbox)
osunionrgn	:: !OSRgnHandle !OSRgnHandle !*OSToolbox -> (!OSRgnHandle,!*OSToolbox)
osdiffrgn	:: !OSRgnHandle !OSRgnHandle !*OSToolbox -> (!OSRgnHandle,!*OSToolbox)

//	Region property access functions.
//	osgetrgnbox  retrieves the bounding box of the region.
//	osisemptyrgn determines whether the region is empty (its bounding box is empty). 
osgetrgnbox	:: !OSRgnHandle !*OSToolbox -> (!(!Int,!Int,!Int,!Int),	!*OSToolbox)
osisemptyrgn:: !OSRgnHandle !*OSToolbox -> (!Bool,					!*OSToolbox)
