definition module controllayout


//	Clean Object I/O library, version 1.1

import	ostoolbox, oswindow
import	windowhandle


layoutControls :: !OSWindowMetrics !(!Int,!Int) !(!Int,!Int) !(!Int,!Int) !Size !Size !Point !Point ![WElementHandle .ls .ps] !*OSToolbox
																						  -> (!Size,![WElementHandle .ls .ps],!*OSToolbox)
/*	layoutControls calculates the layout of the controls given the horizontal and vertical margins, item spaces, prefered size, 
	minimum size of the area in which the controls are positioned, the base of the ViewDomain, and the origin. 
	The result size is the actual size.
*/

getCompoundContentRect	:: !OSWindowMetrics !Bool !Bool !Rect -> Rect
getCompoundHScrollRect	:: !OSWindowMetrics !Bool !Bool !Rect -> Rect
getCompoundVScrollRect	:: !OSWindowMetrics !Bool !Bool !Rect -> Rect

getWindowContentRect	:: !OSWindowMetrics !Bool !Bool !Rect -> Rect
getWindowHScrollRect	:: !OSWindowMetrics !Bool !Bool !Rect -> Rect
getWindowVScrollRect	:: !OSWindowMetrics !Bool !Bool !Rect -> Rect

/*	Given whether a CompoundControl/Window has a (Control/Window)HScroll (first Bool), (Control/Window)VScroll (second Bool),
	and the surrounding rectangle of the control/window:
	get(Compound/Window)ContentRect yields the Rect of the content part;
	get(Compound/Window)(H/V)ScrollRect yields the Rect of the horizontal/vertical scroll component.
*/
