definition module windowclipstate


//	Clean Object I/O library, version 1.1


import	wstate


createClipState	:: !OSWindowPtr !Point !Rect !(Maybe Id) ![WElementHandle .ls .ps] !*OSToolbox -> (!ClipState,![WElementHandle .ls .ps],!*OSToolbox)
createClipState`:: !OSWindowPtr !Point !Rect !(Maybe Id) ![WElementHandle`]        !*OSToolbox -> (!ClipState,!*OSToolbox)
/*	createClipState(`) parentWindow parentPos rectangle defaultId items 
		calculate the clipping area of the given items that should be inside the given rectangle.
		The parentWindow argument is the OSWindowPtr of the parent window.
		The parentPos    argument is the left top position of the containing Window/Dialog/Compound control (zero for the first two).
		The defaultId    argument is the Id of the default control.
*/

disposeClipState:: !ClipState !*OSToolbox -> *OSToolbox
/*	disposeClipState disposes the system resources associated with the ClipState.
	The ClipState should not be used anymore after this operation.
*/

validateWindowClipState :: !OSWindowPtr !(WindowHandle .ls .ps) !*OSToolbox -> (!WindowHandle .ls .ps,!*OSToolbox)
validateWindowClipState`:: !OSWindowPtr !WindowHandle`          !*OSToolbox -> (!WindowHandle`,       !*OSToolbox)
/*	validateWindowClipState(`) wPtr windowHandle
		checks that the optional ClipState of the window is valid (clipOk field is True).
		If not, the ClipState is recalculated and the former value is disposed(!!).
*/

invalidateWindowClipState :: !(WindowHandle .ls .ps) -> WindowHandle .ls .ps
invalidateWindowClipState`:: !WindowHandle`			 -> WindowHandle`
/*	validateWindowClipState(`) invalidate the ClipState of the given window.
*/

validateCompoundClipState :: !OSWindowPtr !(Maybe Id) !(WItemHandle .ls .ps) !*OSToolbox -> (!WItemHandle .ls .ps,!*OSToolbox)
validateCompoundClipState`:: !OSWindowPtr !(Maybe Id) !WItemHandle`          !*OSToolbox -> (!WItemHandle`,       !*OSToolbox)
/*	validateCompoundClipState(`) wPtr defaultId compoundControl
		checks that the optional ClipState of the compound control is valid (clipOk field is True).
		If not, the ClipState is recalculated and the former value is disposed(!!).
*/

invalidateCompoundClipState :: !(WItemHandle .ls .ps) -> WItemHandle .ls .ps
invalidateCompoundClipState`:: !WItemHandle`		  -> WItemHandle`
/*	invalidateCompoundClipState(`) invalidate the ClipState of the given compound control.
*/
